# Neper

## Overview

Neper is a software package for polycrystal generation and meshing. It can deal
with 2D and 3D polycrystals with very large numbers of grains.  Its main
features are:

  * Generation of polycrystals from (experimental) morphological properties;
  * Generation of multiscale microstructures;
  * Generation of periodic or semi-periodic microstructures;
  * Generation of polycrystals in non-convex domains;
  * Generation of uniform orientation distributions;
  * Meshing into good-quality elements;
  * Meshing with cohesive elements at interfaces;
  * Visualization and analysis of the tessellations and meshes.

Neper is built around three modules: generation, meshing and visualization. All
the input data are prescribed non-interactively, using command lines and / or
ASCII files. Neper can be compiled and run on any Unix-like system.

## Installation

Installation instructions are provided in the PDF documentation included in the
distribution or available [here](https://rquey.github.io/neper/docs/neper.pdf).
