/* This file is part of the Neper software package. */
/* Copyright (C) 2003-2020, Romain Quey. */
/* See the COPYING file in the top-level directory. */

#ifdef __cplusplus
extern "C"
{
#endif

/// \file neut_t.h
/// \brief
/// \author Romain Quey
/// \bug No known bugs

#ifndef NEUT_T_H
#define NEUT_T_H

#include "neper_config.h"
#include "ut.h"

#include "neut_glo/neut_glo.h"
#include "neut_structs/neut_structs.h"
#include "neut_tesl/neut_tesl.h"
#include "neut_tess/neut_tess.h"
#include "neut_crys/neut_crys.h"
#include "neut_tesse/neut_tesse.h"
#include "neut_mtess/neut_mtess.h"
#include "neut_flatten/neut_flatten.h"
#include "neut_tesr/neut_tesr.h"
#include "neut_debug/neut_debug.h"
#include "neut_seedset/neut_seedset.h"
#include "neut_poly/neut_poly.h"
#include "neut_polymod/neut_polymod.h"
#include "neut_point/neut_point.h"
#include "neut_reg/neut_reg.h"
#include "neut_lloyd/neut_lloyd.h"
#include "neut_topt/neut_topt.h"
#include "neut_sopt/neut_sopt.h"
#include "neut_tdyn/neut_tdyn.h"
#include "neut_nodes/neut_nodes.h"
#include "neut_mesh/neut_mesh.h"
#include "neut_ori/neut_ori.h"
#include "neut_oopt/neut_oopt.h"
#include "neut_prim/neut_prim.h"

#endif				/* NEUT_T_H */

#ifdef __cplusplus
}
#endif
