/* This file is part of the Neper software package. */
/* Copyright (C) 2003-2020, Romain Quey. */
/* See the COPYING file in the top-level directory. */

#ifdef __cplusplus
extern "C"
{
#endif

/// \file neut_v.h
/// \brief Main header file which includes header files required by -V.
/// \author Romain Quey
/// \bug No known bugs

#ifndef NEUT_V_H
#define NEUT_V_H

#include "neper_config.h"
#include "ut.h"

#include "neut_glo/neut_glo.h"
#include "neut_structs/neut_structs.h"
#include "neut_tess/neut_tess.h"
#include "neut_crys/neut_crys.h"
#include "neut_mtess/neut_mtess.h"
#include "neut_tesr/neut_tesr.h"
#include "neut_elt/neut_elt.h"
#include "neut_mesh/neut_mesh.h"
#include "neut_nodes/neut_nodes.h"
#include "neut_debug/neut_debug.h"
#include "neut_povray/neut_povray.h"
#include "neut_data/neut_data.h"
#include "neut_print/neut_print.h"
#include "neut_point/neut_point.h"
#include "neut_part/neut_part.h"
#include "neut_sim/neut_sim.h"

#endif				/* NEUT_V_H */

#ifdef __cplusplus
}
#endif
